function init(hero) {
    hero.setName("Ms Marvel");
    hero.setTier(4); 
    
    hero.setHelmet("item.superhero_armor.piece.mask");
    hero.setChestplate("item.superhero_armor.piece.jacket");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");
    
    hero.addPowers("fiskheroes:healing_factor", "pack:embiggen", "pack:steel_transformation");
       
    hero.addAttribute("FALL_RESISTANCE", 10.0, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.5, 0);
    hero.addAttribute("PUNCH_DAMAGE", 4, 0);
    hero.addAttribute("SPRINT_SPEED", 0.25, 1);
    
   hero.addKeyBind("STEEL_TRANSFORM", "High Five!", 1); 

    hero.addKeyBindFunc("func_GIANT_MODE", giantModeKey, "Embiggen!", 2);
    
			 hero.setDefaultScale(0.85);
	
	
	
    hero.addAttributeProfile("GIANT_MODE", giantProfile);
	
    hero.setAttributeProfile(getAttributeProfile);
    hero.addAttributeProfile("STEEL", steelProfile);
    hero.setAttributeProfile(getAttributeProfile);
    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setTierOverride(getTierOverride);
	

}

function giantModeKey(player, manager) {
    var flag = player.getData("fiskheroes:dyn/giant_mode");
    manager.setData(player, "fiskheroes:dyn/giant_mode", !flag);
    manager.setData(player, "fiskheroes:size_state", flag ? -1 : 1);
    return true;
}

function getTierOverride(entity) {
    return entity.getData("fiskheroes:dyn/giant_mode") ? 6 : 4;
}

function giantProfile(profile) {
    profile.addAttribute("FALL_RESISTANCE", 100.0, 0);
    profile.addAttribute("JUMP_HEIGHT", -1.5, 0);
    profile.addAttribute("PUNCH_DAMAGE", 30, 0);
    profile.addAttribute("SPRINT_SPEED", -0.5, 1);
	profile.addAttribute("REACH_DISTANCE", 5.0, 0);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:dyn/giant_mode_timer") > 0 ? "GIANT_MODE" : null;
}

function isModifierEnabled(entity, modifier) {
    return modifier.name() != "fiskheroes:size_manipulation" || (modifier.id() == "giant") == (entity.getData("fiskheroes:dyn/giant_mode_timer") > 0 || entity.getData("fiskheroes:dyn/giant_mode"));
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "func_GIANT_MODE":
        return entity.getData("fiskheroes:size_state") == 0 && (entity.getData("fiskheroes:dyn/giant_mode") || entity.getData("fiskheroes:dyn/giant_mode_cooldown") == 0);
    case "SIZE_MANIPULATION":
        return !entity.getData("fiskheroes:dyn/giant_mode");
    default:
        return true;
    }
}

function steelProfile(profile) {
    profile.addAttribute("WEAPON_DAMAGE", 0.03, 1);
    profile.addAttribute("PUNCH_DAMAGE", 17, 0);
    profile.addAttribute("SPRINT_SPEED", -0.2, 1);
	
	profile.addAttribute("REACH_DISTANCE", 8.0, 1);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:dyn/steeled") ? "STEEL" : null;
}

function isModifierEnabled(entity, modifier) {
    return modifier.name() == "fiskheroes:transformation" || modifier.name() == "fiskheroes:cooldown" || entity.getData("fiskheroes:dyn/steeled")|| modifier != "fiskheroes:metal_skin";
}
